
//file:///opt/usr/media/Downloads/tizen.html

var resetApp = false;

var DOWNLOAD_IN_PROGRESS = false;

var MainTizen = {};
var PackageId =  tizen.application.getCurrentApplication().appInfo.packageId;

var tizen5 = true;
var tizenAppVersion = "A v4.6";

var folderPath = "/opt/usr/media/Downloads";

var additional = "";

if (tizen5)
{
	additional = "media/";
	folderPath = "/opt/usr/home/owner/content/Downloads/media/";
}

MainTizen.tizenLoad = function (){
	"use strict";

	 if (window.tizen === undefined) {

         setTimeout(
         		function(){
         			MainTizen.log('This application needs to be run on Tizen device');
         		},
         		1000
         );
     }else{
    	setTimeout(
    		function(){
    			MainTizen.registAllKeys();

    			document.addEventListener('keydown', MainTizen.onKeyDown, false);

    			filesystem.list("downloads/" + additional + "Uploads", true);

    	    	tizen.filesystem.resolve(
  	    		      'downloads',
  	    		      function(dir) {
  	    		          dir.createDirectory(additional + "Scripts");
  	    		          dir.createDirectory(additional + "Uploads");
  	    		          dir.createDirectory(additional + "app/javascript");
  	    		          dir.createDirectory(additional + "app/stylesheets");
  	    		          dir.createDirectory(additional + "Content");
  	    		          MainTizen.log("dirs created");
  	    		      }, function(e) {
  	    		          MainTizen.log("Error" + e.message);
  	    		      }, "rw"
  	    		  );

    		},
    		1000
    	);
     }

	 if (localStorage.getItem("EngagePHD") == undefined
			 || localStorage.getItem("EngagePHD") == null
			 || localStorage.getItem("EngagePHD") == "")
	 {

		 try
		 {
			 if (id)
				 localStorage.setItem("EngagePHD", id);
			 else
				 PromptId("");
		 }
		 catch (ee)
		 {
			 PromptId("");
		 }
	 }



};


MainTizen.tizenUnload = function()
{
	MainTizen.log("closing");
	//avVideo.stop();
	//avVideo.close();
	//officeDocument.endOffice();

	tizen.tvwindow.hide(function(){});
};

function PromptId(m)
{

	var disp = "";
	try
	{
		if (id)
			disp = id;
	}
	catch (e)
	{

	}

	if (disp == "")
		disp = localStorage.getItem("EngagePHD");

	captureId = true;
	firstKey = true;
	$("#engageKey").show();
	if (m != "")
	{
		$("#tmpKey").html(m);
	}
	else
		$("#tmpKey").html(disp);

	var table = "<table align='center'>"

	try
	{
		table += "<tr><td align='left'>Version:</td><td align='left'>" + PingHDVersion + "</td></tr>";
	}
	catch (e){}

	try
	{
		table += "<tr><td align='left'>Firmware:</td><td align='left'>" + webapis.productinfo.getFirmware() + "</td></tr>";
	}
	catch (e){}

	try
	{
		table += "<tr><td align='left'>Temperature:</td><td align='left'>" + b2bapis.b2bcontrol.getCurrentTemperature() + "</td></tr>";
	}
	catch (e){}

	try
	{
		table += "<tr><td align='left'>Serial:</td><td align='left'>" + b2bapis.b2bcontrol.getSerialNumber() + "</td></tr>";
	}
	catch (e){}

	try
	{
		table += "<tr><td align='left'>Id:</td><td align='left'>" + id + "</td></tr>";
	}
	catch (e){}

	table += "</table>";

	$("#dbg").html(table);
}

function SaveId(forceDownload)
{
	var download = false;

	 if (localStorage.getItem("EngagePHD") == undefined
			 || localStorage.getItem("EngagePHD") == null
			 || localStorage.getItem("EngagePHD") == ""
			 || localStorage.getItem("EngagePHD") != $("#tmpKey").html())
	 {
		 download = true;
	 }

 	if ($("#tmpKey").html() == "777")
	{
 		filesystem.deleteAllDownloads('downloads/' + additional + 'Uploads');
 		infoKeyCount = 0;
 		captureId = false;
 		currentAssets = [];
 		PromptId("Assets Cleared");
 		return;
	}

	localStorage.setItem("EngagePHD", $("#tmpKey").html());
	MainTizen.log("ID saved: " + $("#tmpKey").html(), true);
	$("#tmpKey").empty();
	$("#engageKey").hide();
	infoKeyCount = 0;
	captureId = false;



	if (download || forceDownload)
		DownloadEngage();
}

var engageBuild = "";
var currentAssets = [];
var engageHost = "";

function DownloadEngage()
{
	//prepare
	//delete all but assets
	//download all
	//restart app

	MainTizen.log("Download Engage", true);
	if (DOWNLOAD_IN_PROGRESS)
	{
		MainTizen.log("Download already in progress", true);
		return;
	}

	DOWNLOAD_IN_PROGRESS = true;

	var id = localStorage.getItem("EngagePHD");

	MainTizen.log("Downloading [" + id + "]", true);

	//engageBuild = Math.floor((Math.random() * 100000) + 1);
	engageBuild = id;

	//filesystem.deleteAllDownloads('downloads/Uploads');

	if (id == "15-2-27" || id == "15-2-39")
	{
		engageHost = "10.0.0.30";
		GoDownload(id);
		return;
	}

	var u = "http://go.pinghd.com/Tv/SimpleValidatePlayer/" + id;
	MainTizen.log("Checking " + u, true);
	MainTizen.log("MAC: " + b2bapis.b2bcontrol.getMACAddress(), true);
	MainTizen.log("IP: " + b2bapis.b2bcontrol.getIPAddress(), true);


	$.get(u, function(data)
	{
		MainTizen.log("GO found id: [" + data + "]", true);

		if (data == "true")
		{
			engageHost = "go.pinghd.com";
			GoDownload(id);

		}
		else
		{
			$.get("http://dev.pinghd.com/Tv/SimpleValidatePlayer/" + id, function(d)
			{
				MainTizen.log("Dev found id: [" + d + "]", true);

				if (d == "true")
				{
					engageHost = "dev.pinghd.com";
					GoDownload(id);
				}
				else
				{
					//DOWNLOAD_IN_PROGRESS = false;
					//PromptId("Invalid Id");
					//return;

					$.get("http://test.engagephd.com/Tv/SimpleValidatePlayer/" + id, function(t)
					{
						MainTizen.log("test found id: [" + t + "]", true);

						if (t == "true")
						{
							engageHost = "test.engagephd.com";
							GoDownload(id);
						}
						else
						{
							DOWNLOAD_IN_PROGRESS = false;
							PromptId("Invalid Id");
							return;
						}
					});

				}
			});
		}
	}).fail(function(jqXHR, textStatus, errorThrown) {
		MainTizen.log("GO error: [" + JSON.stringify(jqXHR) + "]", true);
		MainTizen.log("GO error: [" + textStatus + "]", true);
		MainTizen.log("GO error: [" + errorThrown + "]", true);
		$.get("http://dev.pinghd.com/Tv/SimpleValidatePlayer/" + id, function(d)
				{
					MainTizen.log("Dev found id: [" + d + "]", true);

					if (d == "true")
					{
						engageHost = "dev.pinghd.com";
						GoDownload(id);
					}
					else
					{
						engageHost = "go.pinghd.com";
						GoDownload(id);
					}
				}).fail(function()
						{

					MainTizen.log("dev error", true);

					engageHost = "go.pinghd.com";
					GoDownload(id);
						});
	});





}

function ResetTizenSpace()
{
	console.log("resetting space");
	currentAssets = [];
	filesystem.deleteAllDownloads('downloads/' + additional + 'Uploads');
	//localStorage.setItem("AssetTime", new Date().getTime());
}

var rackspace = "";

function GoDownload(id)
{
	MainTizen.log("Preparing", true);



	var resetAssets = false;
	var timeOutMs = 1000;

	/*
	try
	{
		var last = parseInt(localStorage.getItem("AssetTime"));
		var diff = new Date().getTime() - last;
		//30 days if (diff < 2592000000)

		if (diff < 2592000000)
			resetAssets = false;

	}
	catch (e){}


	try
	{
		if (resetAssets)
		{

			timeOutMs = 3000;
			//EngageApp.Status("Clearing Assets");
			currentAssets = [];
			filesystem.deleteAllDownloads('downloads/Uploads');
			localStorage.setItem("AssetTime", new Date().getTime());
		}
	}
	catch (e4)
	{
		//EngageApp.Status("Error clearing assets: " + e4.message);
	}
	*/



	filesystem.deleteAllDownloadsTemp('downloads/' + additional + 'Scripts');
	filesystem.deleteAllDownloadsTemp('downloads/' + additional);
	filesystem.deleteAllDownloadsTemp('downloads/' + additional + 'app/javascript');
	filesystem.deleteAllDownloadsTemp('downloads/' + additional + 'Content');
	filesystem.deleteAllDownloadsTemp('downloads/' + additional + 'app/stylesheets');

	var tizenParm = "tizen=true";

	if (tizen5)
		tizenParm = "tizen5=true";

	//var url = "http://" + engageHost + "/Tv/PrepareAndroid/" + id + "?downloadId=" + engageBuild + "&processAssets=false&" + tizenParm;
	var url = "http://" + engageHost + "/Tv/BrightSign/" + id + "?" + tizenParm + "&rackUrl=true&inode=true";

	MainTizen.log("prepare url: " + url, true);

	
	$.ajax({
		url : url,
		timeout : 110 * 1000,
		cache : false
	}).done(function(data, textStatus, jqXHR) {

		
		MainTizen.log("Processing files", true);
		
    	var split = data.split("|");
    	queue = [];

    	for (var x = 0; x < split.length; x++)
		{

			try
			{
	    		if (split[x] == "" || split[x] == "widget.info" || split[x] == "config.xml")
	                continue;
	
	    		var fi = split[x];
	
	    		if (fi.indexOf("Rackspace_") == 0)
				{
	    			continue;
				}
	
	    		if (fi.indexOf("Secure_") == 0)
				{
	    			rackspace = fi.substring(7);
	
	    			continue;
				}
	
	    		if (fi.indexOf("Asset") == 0)
	    			fi = "Uploads/" + split[x];
	
	    		var found = false;
	
	    		for (var y = 0; y < currentAssets.length; y++)
				{
	    			if (fi.indexOf(currentAssets[y]) > -1)
	    				found = true;
	
				}
	
	
	    		if (found)
				{
	    			var d = false;
	    			if (engageHost == "10.0.0.24")
					{
	    				resetApp = true;
	    				d = true;
					}
	
	    			MainTizen.log("Skipping: " + fi, d);
	
	    			continue;
				}
	
	    		queue.push(fi);
	    		
			}
			catch (eee)
			{
				MainTizen.log("failed on file: " + split[x] + ": " + eee.message, true);
			}
		
		}

    	download.processQueue();


	}).fail(function(jqXHR, textStatus, errorThrown) {
		//CURRENT_MENU_IN_PROGRESS = false;
		//TempAppend('Error retrieving JSON file ' + errorThrown);
		
		MainTizen.alert("Code: 142: " + errorThrown + " " + textStatus + " " + JSON.stringify(jqXHR));
		MainTizen.log("Prepare failed", true);
		DOWNLOAD_IN_PROGRESS = false;
		//b2bapis.b2bcontrol.rebootDevice(function(val){}, function(val){});
		
	});
	
	/*
	$.get( url, function( data )
			{



			}).fail(function(e)
			{
				MainTizen.alert("Code: 142: " + e.message + " " + JSON.stringify(e));
				MainTizen.log("Prepare failed", true);
				DOWNLOAD_IN_PROGRESS = false;
				//b2bapis.b2bcontrol.rebootDevice(function(val){}, function(val){});
			});
	*/

}

function errorCB(err) {
    MainTizen.log( 'The following error occurred: ' +  err.name);
}

function printDirectory(directory, index, directories) {
    MainTizen.log('directoryURI: ' + directory.directoryURI + ' Title: ' + directory.title);
}
function getDirectoriesCB(directories) {
    directories.forEach(printDirectory);
}

var queue = [];

var captureId = false;
var firstKey = false;

var infoKeyCount = 0;
var keysProc = false;
/**
 * Handles a key press
 * @param {KeyboardEvent} event
 */
MainTizen.onKeyDown = function (event) {
	"use strict";
	var keyCode = event.keyCode;

	switch (keyCode)
	{
		case 13:    // Enter

	    	if (captureId)
	    	{
    			SaveId(true);
	    		return;
	    	}


			MainTizen.log("firmware: " + webapis.productinfo.getFirmware());
			//getProductInfo();
	        break;

	    case 457:   // info

	    	if (captureId)
	    	{
	    		SaveId(false);
	    		return;
	    	}

	    	infoKeyCount++;

	    	MainTizen.log("info: " + infoKeyCount);

    		setTimeout(function()
			{
				infoKeyCount = 0;
			}, 60000);

	    	if (infoKeyCount > 3)
    		{
	    		infoKeyCount = 0;

	    		PromptId("");

    		}
	        break;

	    case 48: //Key minus

			if (captureId)
			{
				if (firstKey)
				{
				firstKey= false;
				$("#tmpKey").html("");
				}
				$("#tmpKey").append("0");
				return;
			}
	    	break;

	    case 49: //Key minus

			if (captureId)
			{
				if (firstKey)
				{
				firstKey= false;
				$("#tmpKey").html("");
				}
				$("#tmpKey").append("1");
				return;
			}
	    	break;

	    case 50: //Key minus

			if (captureId)
			{
				if (firstKey)
				{
				firstKey= false;
				$("#tmpKey").html("");
				}
				$("#tmpKey").append("2");
				return;
			}
	    	break;

	    case 51: //Key minus

			if (captureId)
			{
				if (firstKey)
				{
				firstKey= false;
				$("#tmpKey").html("");
				}
				$("#tmpKey").append("3");
				return;
			}
	    	break;

	    case 52: //Key minus

			if (captureId)
			{
				if (firstKey)
				{
				firstKey= false;
				$("#tmpKey").html("");
				}
				$("#tmpKey").append("4");
				return;
			}
	    	break;

	    case 53: //Key minus

			if (captureId)
			{
				if (firstKey)
				{
				firstKey= false;
				$("#tmpKey").html("");
				}
				$("#tmpKey").append("5");
				return;
			}
	    	break;

	    case 54: //Key minus

			if (captureId)
			{
				if (firstKey)
				{
				firstKey= false;
				$("#tmpKey").html("");
				}
				$("#tmpKey").append("6");
				return;
			}
	    	break;

	    case 55: //Key minus

			if (captureId)
			{
				if (firstKey)
				{
				firstKey= false;
				$("#tmpKey").html("");
				}
				$("#tmpKey").append("7");
				return;
			}
	    	break;

	    case 56: //Key minus

			if (captureId)
			{
				if (firstKey)
				{
				firstKey= false;
				$("#tmpKey").html("");
				}
				$("#tmpKey").append("8");
				return;
			}
	    	break;

	    case 57: //Key minus

			if (captureId)
			{
				if (firstKey)
				{
				firstKey= false;
				$("#tmpKey").html("");
				}
				$("#tmpKey").append("9");
				return;
			}
	    	break;

	    case 403: //Key red

			if (captureId)
			{
				if (firstKey)
				{
				firstKey= false;
				$("#tmpKey").html("");
				}
				$("#tmpKey").append(".");
				return;
			}
	    	break;

	    case 415:
	    case 189: //Key minus

			if (captureId)
			{
				if (firstKey)
				{
				firstKey= false;
				$("#tmpKey").html("");
				}
				$("#tmpKey").append("-");
				return;
			}
	    	break;


	    case 10009: // Return

	    	if (captureId)
	    		{
	    			$("#engageKey").hide();
	    			captureId = false;
	    			infoKeyCount = 0;
	    		return;
	    		}

	    	/*
	        if (avVideo.getState() !== 'IDLE' && avVideo.getState() !== 'NONE') {
	            avVideo.stop();
	        } else {
	            tizen.application.getCurrentApplication().hide();
	        }
	        */
        break;

		default:
			//$("#consoleLog").css("font-size", "x-small").show().append("<br>" + keyCode + " " + event.key);
			MainTizen.log(keyCode);
		break;
	}

	try
	{
	//MainTizen.log("---------------- " + event.key);

		if (captureId == false)
		handleKey(keyCode);
	}
	catch (e){}
};



var logCounter = 0;
/**
 * Adds text to a UI element -  NOTE: THIS FUNCTION SHOULD NOT BE USED ON PRODUCTION APPS, it is only for visual demonstration of what is happening
 * @param {String} text
 */
MainTizen.log = function (text, debug) {
  "use strict";
  console.log(text);



  if (resetApp && debug)
  {
	  logCounter++;
	  if (logCounter % 90 == 0)
	  	$("#consoleLog").html("");

  	$("#consoleLog").css("font-size", "x-small").show().append("<br>" + text);
  }

};

MainTizen.alert = function (text) {
	  "use strict";
	  console.log(text);


	  	$("#consoleLog").css("font-size", "x-small").show().html(text);


	};


/**
 * Generic Error handler for uncaught JS errors
 * @param errMsg
 * @param url
 * @param lineNum
 * @returns {boolean}
 */
window.onerror = function handleError(errMsg, url, lineNum) {
	"use strict";
  MainTizen.log('Error Message: ' + errMsg  + " " + JSON.stringify(errMsg), true);
  MainTizen.log('  URL: ' + url, true);
  MainTizen.log('  Line: ' + lineNum, true);
  return false;
};


var download = {

		processQueue: function()
		{
			var q = queue.shift();//was pop

			$("#engageStatus").show();
			$("#engageQueue").html(queue.length + " " + q);
			$("#engagePct").html();

			

			if (q != undefined)
			{

				MainTizen.log("================ Queue " + queue.length + " ==================");

	            var lastSlash = q.lastIndexOf("/");

	            var folder = "";
	            var file = "";
	            var temp = q;

	            if (lastSlash > -1) {
	                folder = "" + q.substring(0, lastSlash);
	                file = q.substring(lastSlash + 1, q.length);

	            }
	            else
	                file = q;
	            
	            $("#engageQueue").html(queue.length);// + " " + file);

	            var last = file.lastIndexOf(".");
	            var save = file.substring(0, last);
	            var ext = file.substring(last);

	            if (q.indexOf("Asset") > -1)
	            {
	            	if (rackspace != "")
            		{

	            		if (engageHost == "10.0.0.30")
            			{
	            			$("#consoleLog").css("font-size", "x-small").show().html(rackspace + "/" + q.substring(8));
            			}

	            		this.startQueue(rackspace + "/" + q.substring(8), save, folder, file, ext);
	            	}
	            	else
	            		this.startQueue("http://" + engageHost + "/" + q, save, folder, file, ext);
            	}
	            else
	            	//this.startQueue("http://" + engageHost + "/temp/" + engageBuild + "/" + q, save, folder, file, ext);
	            	this.startQueue("http://" + engageHost + "/brightsign/" + engageBuild + "/" + q, save, folder, file, ext);

			}
			else
			{

				$("#engageStatus").hide();
				MainTizen.log("ALLLLLLLLLL Are Done!")
				DOWNLOAD_IN_PROGRESS = false;

				//document.getElementById("frameContainer").contentDocument.location.reload(true);

				//$.get( "http://" + engageHost + "/Tv/CleanupAndroid?downloadId=" + engageBuild);

				//location.reload(true);
				b2bapis.b2bcontrol.rebootDevice(function(val){}, function(val){});

			}
		},

		startQueue: function(url, name, folder, file, ext)
		{
			var tmpFolder = folder;
			if (tmpFolder.length == 0)
				tmpFolder = "downloads/" + additional;
			else
				tmpFolder = "downloads/" + additional + folder;

			var resolveFolder = folder;
			if (resolveFolder.length == 0)
				resolveFolder = folderPath;
			else
				resolveFolder = folderPath + "/" + folder;


			//MainTizen.alert("Processing: " + url + ", save: " + name + ", folder: " + folder + ", file: " + file + ", ext: " + ext, true);

			//engagetmp

				var req = new tizen.DownloadRequest(url, tmpFolder, "engagetmp" + name, "ALL");

            	req.httpHeader['Pragma'] = 'no-cache';

            	var listener = {
            		onprogress:  this.onProgress.bind(this),
                	onpaused: this.onPaused.bind(this),
                	oncanceled:  this.onCancelled.bind(this),
                	oncompleted: function (id, fullPath) {
                        download.id = null;
                        MainTizen.log('+ ' + fullPath);

                        //filesystem.listDownloadedFiles();

                        tizen.filesystem.resolve(
                        		resolveFolder,
                        	       function(dir)
                        	       {
                        				dir.moveTo(fullPath,
                        						resolveFolder+ "/" + file,
                        						true,
                        						function()
                        						{
                        							MainTizen.log("File copied");
                        						},
                        						function(m)
                        						{
                        							MainTizen.log("File error: " + fullPath + " -- " + resolveFolder + "/" + file + " " + m, true);
                        						});

                        				download.processQueue();
                        	       },
                        	       function(e)
                        	       {
                        	           //TempAppend("<br>Error resolving: " + e.message);
                        	    	   download.processQueue();

                        	       }, "rw");


                    },
                	onfailed: this.onFailed.bind(this)
            	};

            	this.id = tizen.download.start(req, listener);


		},

        getInfo: function () {
            var downloadPossible = tizen.systeminfo.getCapability(
                'http://tizen.org/feature/download');

            var wifiCapable = tizen.systeminfo.getCapability(
                'http://tizen.org/feature/network.wifi');

            MainTizen.log('Download possible: ' + downloadPossible);
            MainTizen.log('Wifi capable: ' + wifiCapable);
        },

        start: function (url, name) {
            var req = new tizen.DownloadRequest(url, 'downloads', name, 'ALL');

            req.httpHeader['Pragma'] = 'no-cache';

            var listener = {
                onprogress:  this.onProgress.bind(this),
                onpaused: this.onPaused.bind(this),
                oncanceled:  this.onCancelled.bind(this),
                oncompleted: this.onComplete.bind(this),
                onfailed: this.onFailed.bind(this)
            };

            this.id = tizen.download.start(req, listener);


        },

        pause: function () {
            if (this.id && tizen.download.getState(this.id) === 'DOWNLOADING') {
                try {
                    tizen.download.pause(this.id)
                } catch (e) {
                	MainTizen.log(e.message);
                }
            }
        },

        resume: function () {

            if (this.id && tizen.download.getState(this.id) === 'PAUSED') {
                try {
                    tizen.download.resume(this.id)
                } catch (e) {
                	MainTizen.log(e.message);
                }
            }
        },

        cancel: function () {
            var state;
            var isCorrectState;

            if (! this.id) {
                return;
            }

            state = tizen.download.getState(this.id);

            isCorrectState = state === 'QUEUED'
                || state === 'DOWNLOADING'
                || state === 'PAUSED';

            if (this.id && isCorrectState) {
                try {
                    tizen.download.cancel(this.id)
                } catch (e) {
                	MainTizen.log(e.message);
                }
            }
        },

        onProgress: function (id, receivedSize, totalSize)
        {
        	var pct = (receivedSize / totalSize)*100;

        	if (pct < 100)
        		$("#engagePct").html(pct.toFixed(0) + '%');
        	else
        		$("#engagePct").html("");

        	MainTizen.log('Downloaded: ' + receivedSize + ' of ' + totalSize + ' ' + pct.toFixed(1) + '%');

        },

        onPaused: function (id) {
        	MainTizen.log('Download paused: ' + id);
        },

        onComplete: function (id, fullPath) {
            this.id = null;
            MainTizen.log('Download completed: ' + fullPath);

            $("#frameContainer").attr("src", "file://" + folderPath + "/tizen2.html");



            filesystem.listDownloadedFiles();

            this.processQueue();
        },

        onCancelled: function (id) {
            this.id = null;
            MainTizen.log('Download cancelled: ' + this.id);


            filesystem.listDownloadedFiles();
        },

        onFailed: function (error) {
            this.id = null;
            MainTizen.log('Download fail: ' + error, true);

            this.processQueue();
        }

    };


    /**
     * Object handling filesystem operations
     */
    var filesystem = {

        deleteAllDownloads: function (path) {

            function deleteFile (handle, file) {
                handle.deleteFile(file.fullPath, function () {});
            }

            this.iterate(path, deleteFile);
        },

        deleteAllDownloadsTemp: function (path) {

            function deleteFile (handle, file)
            {
            	if (file.fullPath.indexOf("engagetmp") > -1)
            		handle.deleteFile(file.fullPath, function () {});
            }

            this.iterate(path, deleteFile);
        },

        deleteTemp: function (path, temp, action) {

            function deleteFile (handle, file) {
            	if (file.indexOf(temp) > -1)
            		handle.deleteFile(file.fullPath, function () {});
            }

            this.iterate(path, deleteFile);
            action();
        },

        list: function(path, saveName) {

        	MainTizen.log("listing ======= " + path);

            tizen.filesystem.resolve(
                    path,
                    function (handle) {
                        if (handle.isDirectory) {
                        	//this.list(handle.fullPath);
                            handle.listFiles(function (files)

                    		{
                            	try
                            	{

                                files.forEach(function (file) {
                                    //callback(handle, file);

                                	if (saveName)
                                		currentAssets.push(file.name);

                                	//MainTizen.log(path + ' File ' + file.name + ' path: ' + file.fullPath);
                                });
                            	}
                            	catch (e)
                            	{
                            		MainTizen.log("Error with handle: " + e.message);
                            	}
                            });
                        }
                    },
                    function (e) {
                        MainTizen.log('Error' + e.message);
                    },
                    'rw'
                );

        },

        listDebug: function(path) {

        	MainTizen.log("listing " + path, true);

            tizen.filesystem.resolve(
                    path,
                    function (handle) {
                        if (handle.isDirectory) {
                        	//this.list(handle.fullPath);
                            handle.listFiles(function (files)

                    		{
                            	try
                            	{

                                files.forEach(function (file) {
                                    //callback(handle, file);



                                	MainTizen.log(path + ' File ' + file.name + ' path: ' + file.fullPath, true);
                                });
                            	}
                            	catch (e)
                            	{
                            		MainTizen.log("Error with handle: " + e.message);
                            	}
                            });
                        }
                    },
                    function (e) {
                        MainTizen.log('Error' + e.message);
                    },
                    'rw'
                );

        },

        listDownloadedFiles: function () {

            function listFile(handle, file) {
                MainTizen.log('File ' + file.name + ' path: ' + file.fullPath);
            }


             this.iterate('downloads', listFile);
        },

        iterate: function (path, callback) {

        	MainTizen.log("Dir listing ========= " + path);

            tizen.filesystem.resolve(
                path,
                function (handle) {

                    if (handle.isDirectory) {
                    	//this.list(handle.fullPath);
                        handle.listFiles(function (files)
                        {
                        	try
                        	{
                            files.forEach(function (file) {
                                callback(handle, file);
                            });
                        	}
                        	catch (e)
                        	{
                        		MainTizen.log("error with handle2: " + e.message);

                        	}

                        });
                    }
                },
                function (e) {
                    log('Error' + e.message);
                },
                'rw'
            );
        }
    };



MainTizen.registAllKeys = function () {
	"use strict";
	try {
        tizen.tvinputdevice.getSupportedKeys()
            .forEach(function (k){
                if ([
                     'Exit',
                    'ColorF0Red',
                    'ColorF1Green',
                    'ColorF2Yellow',
                    'ColorF3Blue',
                    'MediaFastForward',
                    'MediaPause',
                    'MediaPlay',
                    'MediaPlayPause',
                    'MediaRecord',
                    'MediaRewind',
                    'MediaStop',
                    'Info',
                    'ChannelUp',
                    'ChannelDown',
                    '1',
                    '2',
                    '3',
                    '4',
                    '5',
                    '6',
                    '7',
                    '8',
                    '9',
                    '0',
                    'Minus'
                ].indexOf(k.name) > -1) {
                    tizen.tvinputdevice.registerKey(k.name);
                    //MainTizen.log('Subscribed key:'+ k.name + ' ' + k.code);
                }
            });
    } catch (e) {
        MainTizen.log('Could not subscribe keys, exception occurred:'+ e);
    }


};



